<template>
  <div>
    <header>
      <h2>Prodotto selezionato:</h2>
      <p>{{  idCard  }}</p>
    </header>

    <main>

        <section>
          <h3>Prodotti</h3>
          <product-card
            v-for="item in sourceData"
            :item="item"
            @button-click="getSelectdProduct"
            :key="item.id"
          />
        </section>

        <section>
          <h3>Prodotto speciale</h3>
          <product-card
            :item="specialProduct"
            description-color="green"
            @button-click="specialProductButtonClicked"
          >
            <template v-slot:header="slotProps">
              <h2>{{  specialProduct.name  }}</h2>
              <p>Random number dal componente: {{  slotProps.randNum  }}</p>
              <hr>
              <p>Saluti dal componente: {{  slotProps.saluti  }}</p>
            </template>
          </product-card>
        </section>
    </main>
  </div>
</template>

<script>
import jsonData from './data.json';
import ProductCard from '@/components/ProductCard.vue';

export default {
  name: 'App',

  components: {
    ProductCard,
  },

  data() {
    return {
      sourceData: jsonData,
      idCard: '',
    };
  },
  computed: {
    specialProduct() {
      return this.sourceData[0];
    }
  },

  methods: {
    getSelectdProduct(id) {
      // const found = this.dataList.find((x) => x.id === id);
      this.idCard = id;
    },

    specialProductButtonClicked(id) {
      console.log('Hai fatto click sul prodotto speciale', id);
    }
  },
};
</script>

<style scoped>
* {
  box-sizing: border-box;
}

p {
  display: inline;
}

header {
  display: flex;
  justify-content: space-between;
  align-items: center;
  box-shadow: 10px 10px 5px rgba(31, 29, 29, 0.288);
  position: sticky;
  top: 0;
  left: 0;
  background-color: whitesmoke;
}

.container {
  padding: 2px 16px;
}

hr {
  background-color: #999;
  border-width: 0;
  color: #999;
  height: 1px;
  line-height: 0;
  margin: 0.5em 0;
  text-align: center;
}

h4 {
  text-align: center;
  margin: auto;
  padding: 1em;
  font-weight: bold;
}

a {
  text-decoration: none;
  color: green;
}

a:hover {
  cursor: pointer;
}

button {
  background-image: linear-gradient(#42a1ec, #0070c9);
  border: 1px solid #0077cc;
  border-radius: 4px;
  box-sizing: border-box;
  color: #ffffff;
  cursor: pointer;
  direction: ltr;
  display: block;
  font-family: "SF Pro Text", "SF Pro Icons", "AOS Icons", "Helvetica Neue",
    Helvetica, Arial, sans-serif;
  font-size: 17px;
  font-weight: 400;
  letter-spacing: -0.022em;
  line-height: 1.47059;
  min-width: 30px;
  overflow: visible;
  padding: 4px 15px;
  text-align: center;
  user-select: none;
  -webkit-user-select: none;
  touch-action: manipulation;
  white-space: nowrap;
}

button:disabled {
  cursor: default;
  opacity: 0.3;
}

button:hover {
  background-image: linear-gradient(#51a9ee, #147bcd);
  border-color: #1482d0;
  text-decoration: none;
}

button:active {
  background-image: linear-gradient(#3d94d9, #0067b9);
  border-color: #006dbc;
  outline: none;
}

button:focus {
  box-shadow: rgba(131, 192, 253, 0.5) 0 0 0 3px;
  outline: none;
}
</style>
